#ifndef __PROCBAR_H__
#define __PROCBAR_H__

#include <gnome.h>
#include <gtk/gtkhbox.h>

BEGIN_GNOME_DECLS

#define GNOME_PROC_BAR(obj)         GTK_CHECK_CAST (obj, gnome_proc_bar_get_type (), GnomeProcBar)
#define GNOME_PROC_BAR__CLASS(klass) GTK_CHECK_CLASS_CAST (klass, gnome_proc_bar_get_type (), GnomeProcBarClass)
#define GNOME_IS_PROC_BAR(obj)      GTK_CHECK_TYPE (obj, gnome_proc_bar_get_type ())

typedef struct _GnomeProcBar GnomeProcBar;
typedef struct _GnomeProcBarClass GnomeProcBarClass;

struct _GnomeProcBar {

	GtkHBox hbox;

	GtkWidget *bar;
	GtkWidget *label;
	GtkWidget *frame;

	GdkPixmap *bs;
	GdkColor *colors;

	gint colors_allocated;
	gint first_request;
	gint n;
	gint tag;

	unsigned *last;

	gint (*cb)();
};

struct _GnomeProcBarClass {
	GtkHBoxClass parent_class;
};

guint       gnome_proc_bar_get_type        (void);
GtkWidget * gnome_proc_bar_new             (GtkWidget *label,
					    gint n, GdkColor *colors,
					    gint (*cb)());
void        gnome_proc_bar_set_values      (GnomeProcBar *pb, unsigned val []);
void        gnome_proc_bar_start           (GnomeProcBar *pb, gint time);
void        gnome_proc_bar_stop            (GnomeProcBar *pb);
GtkWidget * gnome_proc_bar_properties      (GnomeProcBar *pb, gchar *texts []);

END_GNOME_DECLS

#endif
